HDU 3342 拓扑排序

来源:互联网 发布:移动公司网络维修电话 编辑:程序博客网 时间:2024/05/20 22:01

Legal or Not

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3176    Accepted Submission(s): 1438


Problem Description
ACM-DIY is a large QQ group where many excellent acmers get together. It is so harmonious that just like a big family. Every day,many "holy cows" like HH, hh, AC, ZT, lcc, BF, Qinz and so on chat on-line to exchange their ideas. When someone has questions, many warm-hearted cows like Lost will come to help. Then the one being helped will call Lost "master", and Lost will have a nice "prentice". By and by, there are many pairs of "master and prentice". But then problem occurs: there are too many masters and too many prentices, how can we know whether it is legal or not?

We all know a master can have many prentices and a prentice may have a lot of masters too, it's legal. Nevertheless,some cows are not so honest, they hold illegal relationship. Take HH and 3xian for instant, HH is 3xian's master and, at the same time, 3xian is HH's master,which is quite illegal! To avoid this,please help us to judge whether their relationship is legal or not. 

Please note that the "master and prentice" relation is transitive. It means that if A is B's master ans B is C's master, then A is C's master.
 

Input
The input consists of several test cases. For each case, the first line contains two integers, N (members to be tested) and M (relationships to be tested)(2 <= N, M <= 100). Then M lines follow, each contains a pair of (x, y) which means x is y's master and y is x's prentice. The input is terminated by N = 0.
TO MAKE IT SIMPLE, we give every one a number (0, 1, 2,..., N-1). We use their numbers instead of their names.
 

Output
For each test case, print in one line the judgement of the messy relationship.
If it is legal, output "YES", otherwise "NO".
 

Sample Input
3 20 11 22 20 11 00 0
 

Sample Output
YESNO


拓扑排序判断是否存在环..

入度..

#include<iostream>using namespace std;int map[555][555];int rudu[555];int vis[555];int n,m,top;//n为顶点数,m为边数void tuopu(){int i,k;bool flag=true;int cnt=0;for(k=1;k<=n;k++){for(i=1;i<=n;i++){if(!rudu[i]&&!vis[i]){top=i;vis[top]=1;cnt++;break;}}for(i=1;i<=n;i++){if(map[top][i]==1)rudu[i]--;}}if(cnt==n)cout<<"YES"<<endl;elsecout<<"NO"<<endl;}int main(){int x,y,i,l;while(cin>>n>>m&&n){memset(rudu,0,sizeof(rudu));memset(map,0,sizeof(map));memset(vis,0,sizeof(vis));for(i=1;i<=m;i++){cin>>x>>y;if(map[x+1][y+1]!=1)//考虑出现重边的情况rudu[y+1]++;map[x+1][y+1]=1;}l=n;tuopu();}return 0;}